using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using MediatR;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;

namespace MediatrExample
{
    public class Startup
    {
        // This method gets called by the runtime. Use this method to add services to the container.
        // For more information on how to configure your application, visit https://go.microsoft.com/fwlink/?LinkID=398940
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddMediatR(System.Reflection.Assembly.GetExecutingAssembly());
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }

            app.UseRouting();

            app.UseEndpoints(endpoints =>
            {
                endpoints.MapGet("/request", async context =>
                {
                    IMediator mediator = context.RequestServices.GetRequiredService<IMediator>();
                    Ping ping = new Ping() { Title = "TestTitle" };
                    string result = await mediator.Send(ping);
                    await context.Response.WriteAsync(result);
                });

                endpoints.MapGet("/noty", async context =>
                {
                    IMediator mediator = context.RequestServices.GetRequiredService<IMediator>();
                    NotyPing notyPing = new NotyPing { Message = "Test Noty" };
                    //SubNotyPing notyPing = new SubNotyPing
                    //{
                    //    Message = "Test Noty",
                    //    CreateDate = DateTime.Now.AddMinutes(1)
                    //};
                    await mediator.Publish(notyPing);
                    await context.Response.WriteAsync("Notification OK");
                });


                endpoints.MapGet("/", async context =>
                {
                    await context.Response.WriteAsync("Hello World!");
                });
            });
        }
    }
}
